Skip to content

# Class: PersistentVolumeClaim

## Hierarchy

- KubeObject

↳ PersistentVolumeClaim

## Implements

- ItemObject

## Index

### Constructors

- constructor

### Properties

- apiVersion
- kind
- metadata
- spec
- status
- apiBase
- kind
- namespaced

### Accessors

- selfLink

### Methods

- delete
- getAge
- getAnnotations
- getFinalizers
- getId
- getLabels
- getMatchExpressions
- getMatchLabels
- getName
- getNs
- getOwnerRefs
- getPods
- getResourceVersion
- getSearchFields
- getStatus
- getStorage
- getTimeDiffFromNow
- toPlainObject
- update
- create
- isJsonApiData
- isJsonApiDataList
- isKubeJsonApiListMetadata
- isKubeJsonApiMetadata
- isNonSystem
- isPartialJsonApiData
- stringifyLabels

## Constructors

### constructor

+ new PersistentVolumeClaim(`data`: KubeJsonApiData): PersistentVolumeClaim

Inherited from KubeObject.constructor

Defined in src/renderer/api/kube-object.ts:138

Parameters:

Name | Type
--- | ---
`data` | KubeJsonApiData

Returns: PersistentVolumeClaim

## Properties

### apiVersion

• apiVersion: string

Inherited from KubeObject.apiVersion

Defined in src/renderer/api/kube-object.ts:144

### kind

• kind: string

Inherited from KubeObject.kind

Defined in src/renderer/api/kube-object.ts:145

### metadata

• metadata: IKubeObjectMetadata

Inherited from KubeObject.metadata

Defined in src/renderer/api/kube-object.ts:146

### spec

• spec: object

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:30

#### Type declaration:

- accessModes: string[]

- resources(): object

- requests(): object

  - storage: string

- selector(): object

- matchExpressions: object[]

- matchLabels(): object

  - release: string

- storageClassName: string

### status

• status: object

Overrides KubeObject.status

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:49

#### Type declaration:

- phase: string

### `Static` apiBase

▪ apiBase: string = "/api/v1/persistentvolumeclaims"

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:28

### `Static` kind

▪ kind: string = "PersistentVolumeClaim"

Overrides KubeObject.kind

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:26

### `Static` namespaced

▪ namespaced: boolean = true

Overrides KubeObject.namespaced

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:27

## Accessors

### selfLink

• get selfLink(): string

Inherited from KubeObject.selfLink

Defined in src/renderer/api/kube-object.ts:149

Returns: string

## Methods

### delete

▸ delete(`params?`: JsonApiParams): Promise‹KubeJsonApiData›

Inherited from KubeObject.delete

Defined in src/renderer/api/kube-object.ts:238

Parameters:

Name | Type
--- | ---
`params?` | JsonApiParams

Returns: Promise‹KubeJsonApiData›

### getAge

▸ getAge(`humanize`: boolean, `compact`: boolean, `fromNow`: boolean): string | number

Inherited from KubeObject.getAge

Defined in src/renderer/api/kube-object.ts:174

Parameters:

Name | Type | Default
--- | --- | ---
`humanize` | boolean | true
`compact` | boolean | true
`fromNow` | boolean | false

Returns: string | number

### getAnnotations

▸ getAnnotations(`filter`: boolean): string[]

Inherited from KubeObject.getAnnotations

Defined in src/renderer/api/kube-object.ts:195

Parameters:

Name | Type | Default
--- | --- | ---
`filter` | boolean | false

Returns: string[]

### getFinalizers

▸ getFinalizers(): string[]

Inherited from KubeObject.getFinalizers

Defined in src/renderer/api/kube-object.ts:187

Returns: string[]

### getId

▸ getId(): string

Inherited from KubeObject.getId

Defined in src/renderer/api/kube-object.ts:153

Returns: string

### getLabels

▸ getLabels(): string[]

Inherited from KubeObject.getLabels

Defined in src/renderer/api/kube-object.ts:191

Returns: string[]

### getMatchExpressions

▸ getMatchExpressions(): object[]

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:77

Returns: object[]

### getMatchLabels

▸ getMatchLabels(): string[]

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:70

Returns: string[]

### getName

▸ getName(): string

Inherited from KubeObject.getName

Defined in src/renderer/api/kube-object.ts:161

Returns: string

### getNs

▸ getNs(): string

Inherited from KubeObject.getNs

Defined in src/renderer/api/kube-object.ts:165

Returns: string

### getOwnerRefs

▸ getOwnerRefs(): object[]

Inherited from KubeObject.getOwnerRefs

Defined in src/renderer/api/kube-object.ts:205

Returns: object[]

### getPods

▸ getPods(`allPods`: Pod[]): Pod[]

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:53

Parameters:

Name | Type
--- | ---
`allPods` | Pod[]

Returns: Pod[]

### getResourceVersion

▸ getResourceVersion(): string

Inherited from KubeObject.getResourceVersion

Defined in src/renderer/api/kube-object.ts:157

Returns: string

### getSearchFields

▸ getSearchFields(): string[]

Inherited from KubeObject.getSearchFields

Defined in src/renderer/api/kube-object.ts:214

Returns: string[]

### getStatus

▸ getStatus(): string

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:83

Returns: string

### getStorage

▸ getStorage(): string

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:64

Returns: string

### getTimeDiffFromNow

▸ getTimeDiffFromNow(): number

Inherited from KubeObject.getTimeDiffFromNow

Defined in src/renderer/api/kube-object.ts:170

Returns: number

### toPlainObject

▸ toPlainObject(): object

Inherited from KubeObject.toPlainObject

Defined in src/renderer/api/kube-object.ts:226

Returns: object

### update

▸ update‹T›(`data`: Partial‹T›): Promise‹T›

Inherited from KubeObject.update

Defined in src/renderer/api/kube-object.ts:231

Type parameters:

▪ T: KubeObject

Parameters:

Name | Type
--- | ---
`data` | Partial‹T›

Returns: Promise‹T›

### `Static` create

▸ create(`data`: any): KubeObject‹›

Inherited from KubeObject.create

Defined in src/renderer/api/kube-object.ts:74

Parameters:

Name | Type
--- | ---
`data` | any

Returns: KubeObject‹›

### `Static` isJsonApiData

▸ isJsonApiData(`object`: unknown): object is KubeJsonApiData

Inherited from KubeObject.isJsonApiData

Defined in src/renderer/api/kube-object.ts:82

Parameters:

Name | Type
--- | ---
`object` | unknown

Returns: object is KubeJsonApiData

### `Static` isJsonApiDataList

▸ isJsonApiDataList‹T›(`object`: unknown, `verifyItem`: function): object is KubeJsonApiDataList‹T›

Inherited from KubeObject.isJsonApiDataList

Defined in src/renderer/api/kube-object.ts:124

Type parameters:

▪ T

Parameters:

▪ object: unknown

▪ verifyItem: function

▸ (`val`: unknown): val is T

Parameters:

Name | Type
--- | ---
`val` | unknown

Returns: object is KubeJsonApiDataList‹T›

### `Static` isKubeJsonApiListMetadata

▸ isKubeJsonApiListMetadata(`object`: unknown): object is KubeJsonApiListMetadata

Inherited from KubeObject.isKubeJsonApiListMetadata

Defined in src/renderer/api/kube-object.ts:91

Parameters:

Name | Type
--- | ---
`object` | unknown

Returns: object is KubeJsonApiListMetadata

### `Static` isKubeJsonApiMetadata

▸ isKubeJsonApiMetadata(`object`: unknown): object is KubeJsonApiMetadata

Inherited from KubeObject.isKubeJsonApiMetadata

Defined in src/renderer/api/kube-object.ts:99

Parameters:

Name | Type
--- | ---
`object` | unknown

Returns: object is KubeJsonApiMetadata

### `Static` isNonSystem

▸ isNonSystem(`item`: KubeJsonApiData | KubeObject): boolean

Inherited from KubeObject.isNonSystem

Defined in src/renderer/api/kube-object.ts:78

Parameters:

Name | Type
--- | ---
`item` | KubeJsonApiData | KubeObject

Returns: boolean

### `Static` isPartialJsonApiData

▸ isPartialJsonApiData(`object`: unknown): object is Partial‹KubeJsonApiData›

Inherited from KubeObject.isPartialJsonApiData

Defined in src/renderer/api/kube-object.ts:115

Parameters:

Name | Type
--- | ---
`object` | unknown

Returns: object is Partial‹KubeJsonApiData›

### `Static` stringifyLabels

▸ stringifyLabels(`labels?`: object): string[]

Inherited from KubeObject.stringifyLabels

Defined in src/renderer/api/kube-object.ts:134

Parameters:

Name | Type
--- | ---
`labels?` | object

Returns: string[]